<?php
namespace Teknisa\PED\Factories;

class ped07700ParametrizacaoClientesPedidosFactory {
    protected $connection;

    public function __construct($entityManager) {
        #initializes default service
        $this->connection = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }

    public function deletaDados($row)
    {
        try{
            $this->connection->beginTransaction();
            $sql = "delete from PRODCLIEPED
                    where
                    CDPRODUTO = :P_CDPRODUTO and
                    CDCLIENTE = :P_CDCLIENTE";
                   
            $param['P_CDCLIENTE']  = $row['CDCLIENTE'];
            $param['P_CDPRODUTO']  = $row['CDPRODUTO'];
            
            $std = $this->connection->prepare($sql);
            $std->execute($param);
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function insertDados($row)
    {
        $param['P_CDPRODUTO']           = $row['CDPRODUTO'];
        $param['P_CDCLIENTE']           = $row['CDCLIENTE'];
        $param['P_CDPRODCLIEPED']       = $row['CDPRODCLIEPED'];
        $param['P_DSPRODCLIEPED']       = $row['DSPRODCLIEPED'];
        $param['P_DSPRODCLIEPEDITEM']   = $row['DSPRODCLIEPEDITEM'];
        
        $query = "INSERT INTO PRODCLIEPED
                  (CDPRODUTO, CDCLIENTE, CDPRODCLIEPED, DSPRODCLIEPED, DSPRODCLIEPEDITEM)
                   VALUES
                  (:P_CDPRODUTO, :P_CDCLIENTE, :P_CDPRODCLIEPED, :P_DSPRODCLIEPED, :P_DSPRODCLIEPEDITEM)";
        try {
            $std = $this->connection->prepare($query);
            $std->execute($param);
        } catch (Exception $e){
            throw $e;
        }  
    }

}