<?php
namespace Teknisa\PED\Services;

use Doctrine\ORM\EntityManager;
//use Geral\Util\DateUtil;
use \Teknisa\Libs\Util\DateUtil;
use Teknisa\Model\Controleproducao\Entities\Tabpreclie;

class ped07700ParametrizacaoClientesPedidosService {
    
    protected $entityManager;
    protected $ped07700ParametrizacaoClientesPedidosFactory;
    
    public function __construct(EntityManager $entityManager, $ped07700ParametrizacaoClientesPedidosFactory)
    {        
        $this->entityManager = $entityManager;
        $this->ped07700ParametrizacaoClientesPedidosFactory = $ped07700ParametrizacaoClientesPedidosFactory;
    }
    
    public function insereProduto(
        $nrorg, $cdcliente, $cdproduto
    ){
        $produto = new Tabpreclie();
        $produto->setNrorg($nrorg);
        $produto->setCdcliente($cdcliente);
        $produto->setCdproduto($cdproduto);

        return $produto;
    }
    
    public static function formataData(
        $data
    ){
        if (!$data)
            return null;

        if (strlen($data) == 19)
            $data = DateUtil::truncateString($data);
        $data = DateUtil::getDataDeString($data);
        $data = DateUtil::truncateData($data);

        return $data;
    }
    
    public function buscaTabpreclie($nrorg, $cdcliente, $cdproduto){
        /** @var $params */
        $params = array();
        $params['nrorg']          = $nrorg;
        $params['cdcliente']     = $cdcliente;
        $params['cdproduto'] = $cdproduto;

        /** @var Tabpreclie $tabpreclie */
        $tabpreclie = $this->entityManager->getRepository(Tabpreclie::class)->findOneBy($params);

        return $tabpreclie;
    }
    
    public function geraProduto($rows) {
        
        try {
            for ($i = 0; $i < count($rows[1]); $i++) {
              for ($e = 0; $e < count($rows[0]); $e++) {
                $currentRow = $rows[0][$e];
                $currentCliente = $rows[1][$i];
                
                
                $Nrorg = $currentRow["NRORG"];
                $Cdcliente = $currentCliente["CDCLIENTE"];
                $Cdproduto = $currentRow["CDPRODUTO"];
                $Vrprecoprod = $currentRow["VRPRECOPROD"];
                $Dtvalini = $this->formataData($currentRow["DTVALINI"]);
                $Dtvalfin = $this->formataData($currentRow["DTVALFIN"]);
                
                $Produto = $this->buscaTabpreclie($Nrorg, $Cdcliente, $Cdproduto);
                
                var_dump($Produto);
                
                if(!$Produto) {
                    $Produto = $this->insereProduto($Nrorg, $Cdcliente, $Cdproduto);   
                }
                
                $Produto->setVrprecoprod($Vrprecoprod);
                $Produto->setDtvalini($Dtvalini);
                $Produto->setDtvalfin($Dtvalfin);
                
                $this->entityManager->persist($Produto);
                var_dump($Produto);
                
              }
            }
            $this->entityManager->flush();
        } catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function deletaDados($row)
    {
        $this->ped07700ParametrizacaoClientesPedidosFactory->deletaDados($row);
    }
    
    public function insertDados ($row)
    {
        $this->ped07700ParametrizacaoClientesPedidosFactory->insertDados($row);
    }

}